%{
#include <stdio.h>
#include <string.h>
#include "ghparser.h"
#include "gh.tab.h"
%}


DIGIT	[0-9]
STARTCHAR	[_a-zA-Z]
WORDCHAR	{DIGIT}|{STARTCHAR}
FILECHAR	{WORDCHAR}|[-.+@#$%()]
FILECHAR1	{FILECHAR}|[/" ]
FILECHAR2	{FILECHAR}|[/' ]
 /* special "start states" for matching */
%s DESC

%%
\.game	return DOTGAME;
\.map	return DOTMAP;
\.m	return DOTM;
\.r	return DOTR;
\.c	return DOTC;
\.d	return DOTD;
\.f	return DOTF;
 /* For future use... */
 /* fq = die quick; fn = die now */
 /* xi = cum inside; xo = cum outside */
\.fq	return DOTFQ;
\.fn	return DOTFN;
\.xi	return DOTXI;
\.xo	return DOTXO;
\.t	return DOTT;
\.o	return DOTO;
\.u	return DOTU;
\.v	return DOTV;
\.x	return DOTX;
,	return COMMA;
\+	return PLUS;
-	return MINUS;
\/	return SLASH;
;	return SEMI;
!	return BANG;
<INITIAL>\[	{ BEGIN DESC; return LBRACKET; }
<DESC>^[ \t]*\][ \t]*$	{ BEGIN INITIAL; return RBRACKET; }
\%\$	return PCTDOL;
\%\/	return PCTSLASH;
\%t	return PCTT;
\%@	return PCTAT;
@+	return ATFLAG;
@-	return ATFLAG;
\n	/* ignore newlines */
[ \t]	/* ignore whitespace */
"//".*	/* ignore c++-style comments */
<DESC>[ \t]*[^]].*	yylval.str = strdup(yytext); return STRING;
{DIGIT}+	yylval.num = atoi(yytext); return INT;
{STARTCHAR}{WORDCHAR}* yylval.str = strdup(yytext); return WORD;
FILECHAR$	yylval.str = strdup(yytext); return FILEPART;
'FILECHAR1+'	yylval.str = strdup(yytext); return QUOTE;
"FILECHAR2+"	yylval.str = strdup(yytext); return QUOTE;
%%
