#ifndef GHPARSER_H
#define GHPARSER_H

#include <string.h>
#include <stdio.h>


#ifdef __cplusplus
extern "C"
{
#else
typedef int bool;
#endif

/******************************************************************
extern int yylex \
               (YYSTYPE * yylval_param,YYLTYPE * yylloc_param );
******************************************************************/
extern FILE* yyin;
typedef struct YYLTYPE
{
    int first_line;
    int first_column;
    int last_line;
    int last_column;
} YYLTYPE;

extern YYLTYPE yylloc;

typedef const char* cstring;
typedef void* pointer;
extern const pointer PNULL;
extern const bool FALSE;
extern const bool TRUE;

const char* mystrcat(const char* str1, const char* str2);

void setFlag(const char* plusminus, const char* flagid);
char* mkImages(const char*, const char*);
char* CombineFName(const char*, const char*);
void SetMap(const char*);
void outputResults(void);
void PopChoices(void);
void SetImages(cstring imgname, cstring animname);
void setDesc(cstring desc);
void AddOption(cstring condFlag, cstring id, cstring text);
void setGameName(cstring gmname);
void AddThing(cstring id, cstring name, cstring image, cstring icon);
void AddCondition(char phase, pointer cond, cstring text);
pointer MkCondInt(cstring condFlag, int plusminus, int value);
pointer MkCondID(cstring ctype, bool minus, cstring id);
void AddMapDot(const char* label, int x, int y, int rad);
void AddRoom(const char* name, const char* id);
void AddCharacter(const char* name, const char* id);
void SetRoomImage(const char* ifname);
void SetRoomAnim(const char* ifname, const char* afname);
void SetCharDesc(const char* desc);
void* mkCondInt(const char* condFlag, const char* plusminus, int value);
void* mkCondID(const char* ctype, const char* minus, const char* id);
void addCondText(const char* text);
void AddDoor(const char* id, const char* arrowname, const char* roomid);
#ifdef __cplusplus
}
#endif

#endif /* GHPARSER_H */

